
#pragma once

#include <boost/call_traits.hpp>
#include <boost/spirit/fusion/sequence/get.hpp>
#include <boost/spirit/fusion/sequence/tuple.hpp>

namespace ketchup {

template< class Derived >
struct gen_pwm_args_type
{
	typedef boost::fusion::tuple<
		Derived&, HWND, UINT, WPARAM, LPARAM, LRESULT&, DWORD, BOOL&
	> type;
};

template< class Derived >
struct gen_pwm_args_reference
{
	typedef typename gen_pwm_args_type<Derived>::type args_type;
	typedef typename boost::call_traits<args_type>::reference type;
};

template< class Derived >
struct gen_pwm_args_param_type
{
	typedef typename gen_pwm_args_type<Derived>::type args_type;
	typedef typename boost::call_traits<args_type>::param_type type;
};

///////////////////////////////////////////////////////////////////////////////
// shortcuts
//
template< class Derived >
static Derived& get_derived(typename gen_pwm_args_param_type<Derived>::type xs)
{
	return boost::fusion::get<0>(xs);
}

template< class Derived >
static HWND get_hWnd(typename gen_pwm_args_param_type<Derived>::type xs)
{
	return boost::fusion::get<1>(xs);
}

template< class Derived >
static UINT get_uMsg(typename gen_pwm_args_param_type<Derived>::type xs)
{
	return boost::fusion::get<2>(xs);
}

template< class Derived >
static WPARAM get_wParam(typename gen_pwm_args_param_type<Derived>::type xs)
{
	return boost::fusion::get<3>(xs);
}

template< class Derived >
static LPARAM get_lParam(typename gen_pwm_args_param_type<Derived>::type xs)
{
	return boost::fusion::get<4>(xs);
}

template< class Derived >
static LRESULT& get_lResult(typename gen_pwm_args_param_type<Derived>::type xs)
{
	return boost::fusion::get<5>(xs);
}

template< class Derived >
static DWORD get_dwMsgMapID(typename gen_pwm_args_param_type<Derived>::type xs)
{
	return boost::fusion::get<6>(xs);
}

template< class Derived >
static BOOL& get_bHandled(typename gen_pwm_args_param_type<Derived>::type xs)
{
	return boost::fusion::get<7>(xs);
}

} // namespace ketchup
